#ifndef _SNAKE_H_
#define _SNAKE_H_

#include <inttypes.h>

enum
{
    SN_HEAD, // Kopf
    SN_FOOD  // Futter
};

#define SEG_MAX 40
    
typedef struct
{
    // Eingestellter Lvel: 0..
    uint8_t level;
    // Verzoegerung zwischen Aufrufen von onTimeChanged
    uint8_t delay;
    // Soviel waechst das Vieh wenns was frisst
    uint8_t grow;
    // Alles bewegt sich auf einem Raster, also mod 1, 2, 4, 8, ...
    uint8_t raster;
    // Laenge der Schlang beim Start
    uint8_t start_len;
} snake_level_t;

typedef struct snake_t
{
    // Kriech-Richtung
    uint8_t dir;
    // Neue Richtung angefordert
    uint8_t new_dir;
    
    // Futter laesst die Schlong wachsen
    uint8_t grow;

    // einzelne Punkte: Kopf, Futter, ...
    union
    {
        struct
        {
            struct { uint8_t x, y; } head;
            struct { uint8_t x, y; } food;
        };
        struct { uint8_t x, y; } p[0];
    };
    
    struct
    {
        // momentan gezeichnetes Element
        // -2, -1: head
        // 0..nseg-1: body
        uint8_t elem;
        // Anzahl noch zu zeichnende Pixel des aktuellen Elements
        uint16_t len;
        // momentane Zeichenrichtung
        uint8_t dir;
        // Momentane Strahlposition
        uint8_t x, y;
        // Alles fertig gemalt
        uint8_t done;
        // Kollisionen
        struct
        {
            uint8_t food;
            uint8_t body;
        } bums;
        
    } draw;
    
    uint8_t changed;
    uint8_t raster_mask;
    
    snake_level_t level;
    
    // Koerper
    struct
    {
        // Index des ersten Segments
        uint8_t start;
        // Anzahl Segmente
        uint8_t nseg;
        // Segmente
        struct
        {
            // Richtung + Laenge
            uint8_t dir, len;
        } seg[SEG_MAX];
    } body;
} snake_t;

extern snake_t snake;
extern void snake_set_level (snake_t*, uint8_t);

#include "menu.h"

extern const menuitem_t menuitem_snake;

#endif /* _SNAKE_H_ */
